
#ifndef PERIPHERAL_H
#define PERIPHERAL_H

#include "Memory.h"
#include "Processor.h"

/**
 * An abstract class representing a peripheral device to the Intellivision
 * master component.
 *
 * @author Kyle Davis
 */
class Peripheral
{

    public:
        virtual INT32 getProcessorCount() = 0;
        virtual void getProcessor(INT32 i, Processor** p) = 0;
        virtual INT32 getMemoryCount() = 0;
        virtual void getMemory(INT32 i, Memory** m) = 0;

};

#endif
