
#ifndef PROCESSOR_H
#define PROCESSOR_H

#include <windows.h>
#include "PlugIn.h"

/**
 * An abstract class representing a processor, which is a hardware component
 * that requires a clock input.
 *
 * @author Kyle Davis
 */
class Processor
{

    public:
        Processor() : isIdle(FALSE) {};
        virtual void reset() = 0;
        virtual INT32 getClockSpeed() = 0;
        virtual INT32 tick() = 0;
        virtual void changePlugIn(PlugIn* plugIn) = 0;

        BOOL isIdle;
/*
        virtual void save(SaveOutputStream sos) throws IOException = 0;
        virtual void load(LoadInputStream lis) throws IOException = 0;
*/

};

#endif
