
#include <iostream>
#include "RAM.h"

using namespace std;

RAM::RAM()
    : image(NULL)
{}

RAM::RAM(INT32 size, INT32 location, INT32 bitWidth)
    : image(NULL)
{
    init(size, location, bitWidth);
}

void RAM::init(INT32 size, INT32 location, INT32 bitWidth)
{
    this->size = size;
    this->location = location;
    this->bitWidth = bitWidth;
    this->trimmer = (1 << bitWidth) -1;
    image = new INT32[size];
}

RAM::~RAM()
{
    if (image != NULL)
        delete[] image;
}

void RAM::reset()
{
    for (INT32 i = 0; i < size; i++)
        image[i] = 0;
}

INT32 RAM::getLocation()
{
    return location;
}

INT32 RAM::peek(INT32 location)
{
    return image[location-this->location];
}

void RAM::poke(INT32 location, INT32 value)
{
    image[location-this->location] = (value & trimmer);
}

INT32 RAM::getSize()
{
    return size;
}

