package com.bliss.emu;

import java.io.*;

public class SaveOutputStream extends OutputStream
{

    SaveOutputStream(OutputStream os) {
        this.os = os;
    }

    public void write(int i) throws IOException {
        os.write(i);
    }

    public void flush() throws IOException {
        os.flush();
    }

    public void close() throws IOException {
        os.close();
    }

    public void writeInt(int i) throws IOException {
        os.write((i & 0xFF000000) >> 24);
        os.write((i & 0x00FF0000) >> 16);
        os.write((i & 0x0000FF00) >> 8);
        os.write(i & 0x000000FF);
    }

    public void writeBoolean(boolean b) throws IOException {
        os.write(b ? 1 : 0);
    }

    private OutputStream os;
}
