
#include "CartridgeType.h"

CartridgeType::CartridgeType(UINT32 crc, CHAR* name, CHAR* producer, CHAR* year,
        UINT32 size, BOOL requiresECS, BOOL usesIntellivoice,
        UINT32 spanStart1, UINT32 spanEnd1)
{
    this->crc = crc;
    this->name = name;
    this->producer = producer;
    this->year = year;
    this->size = size;
    this->ecs = requiresECS;
    this->ivoice = usesIntellivoice;
    this->spans = new MemorySpan[1];
    this->spans[0].memStart = spanStart1;
    this->spans[0].memEnd = spanEnd1;
    this->spanCount = 1;
}

CartridgeType::CartridgeType(UINT32 crc, CHAR* name, CHAR* producer, CHAR* year,
        UINT32 size, BOOL requiresECS, BOOL usesIntellivoice,
        UINT32 spanStart1, UINT32 spanEnd1,
        UINT32 spanStart2, UINT32 spanEnd2)
{
    this->crc = crc;
    this->name = name;
    this->producer = producer;
    this->year = year;
    this->size = size;
    this->ecs = requiresECS;
    this->ivoice = usesIntellivoice;
    this->spans = new MemorySpan[2];
    this->spans[0].memStart = spanStart1;
    this->spans[0].memEnd = spanEnd1;
    this->spans[1].memStart = spanStart2;
    this->spans[1].memEnd = spanEnd2;
    this->spanCount = 2;
}

CartridgeType::CartridgeType(UINT32 crc, CHAR* name, CHAR* producer, CHAR* year,
        UINT32 size, BOOL requiresECS, BOOL usesIntellivoice,
        UINT32 spanStart1, UINT32 spanEnd1,
        UINT32 spanStart2, UINT32 spanEnd2,
        UINT32 spanStart3, UINT32 spanEnd3)
{
    this->crc = crc;
    this->name = name;
    this->producer = producer;
    this->year = year;
    this->size = size;
    this->ecs = requiresECS;
    this->ivoice = usesIntellivoice;
    this->spans = new MemorySpan[3];
    this->spans[0].memStart = spanStart1;
    this->spans[0].memEnd = spanEnd1;
    this->spans[1].memStart = spanStart2;
    this->spans[1].memEnd = spanEnd2;
    this->spans[2].memStart = spanStart3;
    this->spans[2].memEnd = spanEnd3;
    this->spanCount = 3;
}

CartridgeType::CartridgeType(UINT32 crc, CHAR* name, CHAR* producer, CHAR* year,
        UINT32 size, BOOL requiresECS, BOOL usesIntellivoice,
        UINT32 spanStart1, UINT32 spanEnd1,
        UINT32 spanStart2, UINT32 spanEnd2,
        UINT32 spanStart3, UINT32 spanEnd3,
        UINT32 spanStart4, UINT32 spanEnd4)
{
    this->crc = crc;
    this->name = name;
    this->producer = producer;
    this->year = year;
    this->size = size;
    this->ecs = requiresECS;
    this->ivoice = usesIntellivoice;
    this->spans = new MemorySpan[4];
    this->spans[0].memStart = spanStart1;
    this->spans[0].memEnd = spanEnd1;
    this->spans[1].memStart = spanStart2;
    this->spans[1].memEnd = spanEnd2;
    this->spans[2].memStart = spanStart3;
    this->spans[2].memEnd = spanEnd3;
    this->spans[3].memStart = spanStart4;
    this->spans[3].memEnd = spanEnd4;
    this->spanCount = 4;
}

CartridgeType::~CartridgeType() {
    delete[] this->spans;
}

UINT32 CartridgeType::getCrc() {
    return crc;
}

const CHAR* CartridgeType::getName() {
    return name;
}

const CHAR* CartridgeType::getProducer() {
    return producer;
}

const CHAR* CartridgeType::getYear() {
    return year;
}

UINT32 CartridgeType::getSize() {
    return size;
}

BOOL CartridgeType::requiresECS() {
    return ecs;
}

BOOL CartridgeType::usesIntellivoice() {
    return ivoice;
}

UINT32 CartridgeType::getMemorySpanCount() {
    return spanCount;
}

MemorySpan* CartridgeType::getMemorySpan(UINT32 i) {
    return &spans[i];
}


