
#ifndef BANKSWITCHEDROM_H
#define BANKSWITCHEDROM_H

#include "Memory.h"

class BankSwitchedROM : public Memory
{

    public:
        BankSwitchedROM();
        BankSwitchedROM(INT32 size, INT32 page, INT32 location);
        ~BankSwitchedROM();
        void init(INT32 size, INT32 page, INT32 location);
        void reset();
        void loadImage(INT32* image);
        INT32 getSize();
        INT32 getLocation();
        void poke(INT32 location, INT32 value);
        INT32 peek(INT32 location);
/*
        void save(SaveOutputStream sos) throws IOException;
        void load(LoadInputStream lis) throws IOException;
*/

    private:
        INT32  currentPage;
        INT32* image;
        INT32  size;
        INT32  imagePage;
        INT32  location;
        INT32  pageChangeValue;

};

#endif

