
#include "PlugIn.h"

INT32 PlugIn::init(Intellivision* inty) {
    INT32 result;
    if (result = getClockDevice()->init(inty)) {
        return result;
    }

    if (result = getVideoOutputDevice()->init(inty)) {
        getClockDevice()->release(inty);
        return result;
    }

    if (result = getAudioOutputDevice()->init(inty)) {
        getClockDevice()->release(inty);
        getVideoOutputDevice()->release(inty);
        return result;
    }

    if (result = getInputDevice()->init(inty)) {
        getClockDevice()->release(inty);
        getVideoOutputDevice()->release(inty);
        getAudioOutputDevice()->release(inty);
        return result;
    }

    return 0;
}

void PlugIn::release(Intellivision* inty) {
    getInputDevice()->release(inty);
    getAudioOutputDevice()->release(inty);
    getVideoOutputDevice()->release(inty);
    getClockDevice()->release(inty);
}

