
#ifndef WIN32PLUGIN_H
#define WIN32PLUGIN_H

#include "PlugIn.h"
#include "DirectXVideoOutputDevice.h"
#include "DirectXAudioOutputDevice.h"
#include "DirectInputDevice.h"
#include "Win32ClockDevice.h"

class Win32PlugIn : public PlugIn
{
    public:
        VideoOutputDevice* Win32PlugIn::getVideoOutputDevice();
        AudioOutputDevice* Win32PlugIn::getAudioOutputDevice();
        InputDevice* Win32PlugIn::getInputDevice();
        ClockDevice* Win32PlugIn::getClockDevice();

    private:
        DirectXVideoOutputDevice videoOutputDevice;
        DirectXAudioOutputDevice audioOutputDevice;
        DirectInputDevice        inputDevice;
        Win32ClockDevice         clockDevice;

};

#endif

